@import "config";

@mixin controls($theme) {
    .lia-h1 {
        font-size: 200%;
        font-weight: 500;
    }
    .lia-h2 {
        font-size: 175%;
        font-weight: 500;
    }
    .lia-h3 {
        font-size: 150%;
        font-weight: 500;
    }
    .lia-h4 {
        font-size: 125%;
        font-weight: 500;
    }
    .lia-h5 {
        font-size: 110%;
        font-weight: 500;
    }
    .lia-h6 {
        font-size: 105%;
        font-weight: 500;
    }

    .lia-link {
        &:link {
            color: map-get($theme, primary);

            &:hover {
                color: lighten(map-get($theme, primary), 20%);
            }

            &:active {
                color: darken(map-get($theme, primary), 20%);
            }
        }

        &:visited {
            color: map-get($theme, secondary);

            &:hover {
                color: lighten(map-get($theme, secondary), 20%);
            }

            &:active {
                color: darken(map-get($theme, secondary), 20%);
            }
        }
    }

    .lia-code.lia-inline {
        $vert: map-get($config, spacing-smaller);
        $horiz: map-get($config, spacing-small);
        $bg: mix(map-get($theme, background), map-get($theme, primary), 80%);
        $fg: mix(map-get($theme, text), map-get($theme, background), 80%);
        $fg-inv: mix(map-get($theme, text-inv), map-get($theme, background), 80%);

        font-family: "Roboto Mono";
        background: $bg;
        color: color-contrast($bg, $fg, $fg-inv);
        border-bottom-left-radius: map-get($config, spacing-small);
        border-bottom-right-radius: map-get($config, spacing-small);
        padding: $vert $horiz;
        font-size: map-get($config, code-size);
        overflow-x: auto;
        margin: 0px;
        transition: max-height 0.5s ease-out;
    }

    .headless {
        border-top-left-radius: map-get($config, spacing-small);
        border-top-right-radius: map-get($config, spacing-small);
    }

    .lia-code:not(.lia-inline) {
        $bg: mix(map-get($theme, background), map-get($theme, background-inv), 95%);

        font-family: "Roboto Mono";
        background: $bg;
        padding: map-get($config, spacing-normal);
        font-size: map-get($config, code-size);
        overflow-x: auto;
    }

    .lia-accordion {
        $bg: map-get($theme, primary);
        $fg: map-get($theme, background);
        $rd: map-get($config, spacing-small);

        background-color: $bg;
        color: $fg;
        cursor: pointer;
        padding: 6px;
        width: 100%;
        border: none;
        text-align: left;
        outline: none;
        font-size: 15px;
        border-top-left-radius: $rd;
        border-top-right-radius: $rd;
        font-family: "Roboto Mono";
        font-size: map-get($config, code-size);

        .lia-accordion-min-max {
            padding-right: 3px;
            padding-left: 3px;
            .active, &:hover {
                background-color: mix($bg, $fg, 50%);
            }
        }

        .active, &:hover {
            background-color: mix($bg, $fg, 80%);
        }
    }

    .lia-accordion-dummy {
        $bg: map-get($theme, primary);
        $fg: map-get($theme, background);
        $rd: map-get($config, spacing-small);

        background-color: $bg;
        color: $fg;
        cursor: auto;
        padding: 6px;
        width: 100%;
        border: none;
        text-align: left;
        outline: none;
        font-size: 15px;
        border-top-left-radius: $rd;
        border-top-right-radius: $rd;
        transition: 0.4s;
        font-family: "Roboto Mono";
        font-size: map-get($config, code-size);
    }

    .lia-code-stdout {
        font-family: "Roboto Mono";
        background: #111;
        color: #eee;
        padding: map-get($config, spacing-normal);
        margin-top: 0px;
        font-size: map-get($config, code-size);
        overflow-y: auto;
        max-height: 250px;
        border-radius: map-get($config, spacing-small);
        word-wrap: normal;
        word-break: keep-all;
        white-space: pre-wrap;
    }

    .lia-color {
      margin: 0px;
      padding: 0px;
      float: left;
      width: 100%;

      label {
        float: left;
        width: 91px;
        height: 34px;
        margin: 4px;
        background-color: #EFEFEF;
        border-radius: 4px;
        border: 0px;
        overflow: auto;

        box-shadow: 0 3px 1px -2px rgba(0,0,0,.2),
                    0 2px 2px 0    rgba(0,0,0,.14),
                    0 1px 5px 0    rgba(0,0,0,.12);

        span {
          text-align: center;
          padding: 8px 0px;
          display: block;
        }
        input {
          position: absolute;
          top: -9px;
        }

        &:hover {
            cursor: pointer;
            background: #404040;
            color: #F7F7F7;
        }

        &:active {
            box-shadow: -1px -1px 1px #fff;
        }
      }
      input:checked + span {
        background-color: #404040;
        color: #F7F7F7;
      }
      .default {
        background-color: #3f51b5;
        color: #333;
      }
      .amber {
        background-color: #FFC107;
        color: #333;
      }
      .blue {
        background-color: #2196f3;
        color: #333;
      }
      .green {
        background-color: #4caf50;
        color: #333;
      }
      .gray {
        background-color: #607d8b;
        color: #333;
      }
      .purple {
        background-color: #673ab7;
        color: #333;
      }

    }

    .lia-tooltip {
      position: relative;
      display: inline-block;
      .lia-tooltiptext {
        visibility: hidden;
        //width: 120px;
        background-color: black;
        color: #fff;
        text-align: left;
        border-radius: 6px;
        padding: 15px;
        /* Position the tooltip */
        position: absolute;
        z-index: 1;
        top: 100%;
        left: 50%;
        margin-left: -60px;
      }
      &:hover .lia-tooltiptext {
        visibility: visible;
      }
    }

    .lia-label {
      //white-space: nowrap;
      word-wrap: normal;
      word-break: keep-all;
      white-space: pre-wrap;
    }

    .lia-textarea {
        width: 100%;
    }

    .lia-btn,
    .lia-input,
    .lia-label,
    .lia-select {
        $vert: map-get($config, spacing-small);
        $marg: map-get($config, spacing-normal);
        padding: $vert 0;
        margin: $marg;
    }

    .lia-btn {
        $bg: map-get($theme, primary);
        $fg: color-contrast($bg);

        border: none;
        border-radius: map-get($config, spacing-smaller);
        outline: none;
        position: relative;
        overflow: hidden;
        transition: background 0.25s ease-in 0s;
        padding: 0 map-get($config, spacing-large);
        line-height: 2em;

        &:not([disabled]) {
            background: $bg;
            color: $fg;
            box-shadow: 0 3px 1px -2px rgba(0,0,0,.2),
                        0 2px 2px 0    rgba(0,0,0,.14),
                        0 1px 5px 0    rgba(0,0,0,.12);

            &:hover {
                cursor: pointer;
                background: mix($bg, $fg, 80%);
            }
        }

        &[disabled] {
            $fg: color-contrast(map-get($theme, background));

            background: rgba($fg, .12);
            color: rgba($fg, .38);
        }

        &:active {
            box-shadow: -1px -1px 1px #fff;
        }

        .lia-ripple {
            position: absolute;
            display: block;
            border-radius: 50%;
            width: 0;
            height: 0;
            margin: 0;
            background: $fg;
            opacity: 0;
            transition-property: width, height, margin, opacity;
            transition-duration: 0.5s;
            transition-timing-function: ease-out;
            transition-delay: 0s;
        }

        &.lia-selected {
          box-shadow: -1px -1px 1px #000;
        }

        &.lia-success {
            $bg: map-get($theme, success);
            $fg: color-contrast($bg);

            background: $bg;
            color: $fg;

            &:hover {
                background: mix($bg, $fg, 80%);
            }

            .lia-ripple {
                background: $fg;
            }
        }

        &.lia-warning {
            $bg: map-get($theme, warning);
            $fg: color-contrast($bg);

            background: $bg;
            color: $fg;

            &:hover {
                background: mix($bg, $fg, 80%);
            }

            .lia-ripple {
                background: $fg;
            }
        }

        &.lia-failure {
            $bg: map-get($theme, error);
            $fg: color-contrast($bg);

            background: $bg;
            color: $fg;

            &:hover {
                background: mix($bg, $fg, 80%);
            }

            .lia-ripple {
                background: $fg;
            }
        }
    }

    .lia-labeled {
        @include flex(row, nowrap, flex-start, center, flex-start);
        margin-right: map-get($config, spacing-normal);

        & :first-child {
            margin-right: 0;
        }
    }

    .lia-input,
    .lia-textarea,
    .lia-select {
        $bg: map-get($theme, background);
        $fg: color-contrast($bg);

        background: $bg;
        border: none;
        outline: none;
        transition: border-bottom-color 0.5s ease-out 0s;

        &:not([disabled]) {
            color: $fg;
            border-bottom: 1.5px solid mix($bg, $fg, 50%);
        }

        &[disabled] {
            color: rgba($fg, .38);
            border-bottom: 1.5px dotted mix($bg, $fg, 50%);
        }

        &:focus {
            border-bottom-color: map-get($theme, primary);
        }
    }

    input[type='radio'] {
        $bg: map-get($theme, background);
        $fg: color-contrast($bg);
        $snd: map-get($theme, secondary);
        $outline: 2.5px;

        // hide the input but have it still be clickable
        opacity: 0;
        vertical-align: middle;
        position: absolute;
        width: calc(1em + #{$outline} * 2);
        height: calc(1em + #{$outline} * 2);
        margin-right: map-get($config, spacing-small);

        & + .lia-radio-btn {
            margin: $outline;
            clear: none;
            vertical-align: middle;
            display: inline-block;
            box-sizing: border-box;
            border-radius: 50%;
            border: 0.5em solid $bg;
            background: $bg;
            box-shadow: 0 0 0 $outline mix($bg, $fg, 50%);
            width: 1em;
            height: 1em;
            transition-property: background, box-shadow, border;
            transition-duration: 0.25s;
            transition-timing-function: ease-in;
        }

        &:not([disabled]):hover {
            cursor: pointer;
        }

        &:checked + .lia-radio-btn {
            box-shadow: 0 0 0 $outline $snd;
            background: $snd;
            border: 3px solid $bg;
        }

        &[disabled]:checked + .lia-radio-btn {
            $snd: rgba($fg, .38);

            box-shadow: 0 0 0 $outline $snd;
            background: $snd;
        }
    }

    input[type='checkbox'] {
        $bg: map-get($theme, background);
        $fg: color-contrast($bg);
        $snd: map-get($theme, secondary);
        $outline: 2.5px;

        // hide the input but have it still be clickable
        opacity: 0;
        vertical-align: middle;
        position: absolute;
        width: calc(1em + #{$outline} * 2);
        height: calc(1em + #{$outline} * 2);
        margin-right: map-get($config, spacing-small);

        & + .lia-check-btn {
            @include material-icon("", inherit);
            margin: $outline;
            clear: none;
            vertical-align: middle;
            font-weight: 600;
            overflow: hidden;
            box-sizing: border-box;
            border-radius: map-get($config, spacing-tiny);
            border: 0.5em solid $bg;
            box-shadow: 0 0 0 $outline mix($bg, $fg, 50%);
            width: 1em;
            height: 1em;
            background: $bg;
            color: color-contrast($snd);
            transition-property: background, box-shadow, border;
            transition-duration: 0.25s;
            transition-timing-function: ease-in;
        }

        &:not([disabled]):hover {
            cursor: pointer;
        }

        &:checked + .lia-check-btn {
            box-shadow: 0 0 0 $outline $snd;
            border: 0px solid $snd;
            background: $snd;
        }

        &[disabled]:checked + .lia-check-btn {
            $snd: rgba($fg, .38);

            box-shadow: 0 0 0 $outline $snd;
            border: 0px solid $snd;
            background: $snd;
        }
    }

    .lia-hidden {
        display: none;
    }

    .lia-table {
        margin-top: map-get($config, spacing-large);
        margin-bottom: map-get($config, spacing-large);
        $bg: map-get($theme, background);
        $fg: color-contrast($bg);
        $head-bg: mix($bg, $fg, 100%);
        $row-even-bg: mix($bg, $fg, 95%);
        $row-odd-bg: mix($bg, $fg, 100%);
        $head-fg: color-contrast($head-bg);
        $row-even-fg: color-contrast($row-even-bg);
        $row-odd-fg: color-contrast($row-odd-bg);
        $border-color: mix($bg, $fg, 75%);


        border-collapse: collapse;

        .lia-table-head {
            th {
                padding: map-get($config, spacing-normal) map-get($config, spacing-large);
                border: 1px solid $border-color;
            }

            background: $head-bg;
            color: $head-fg;
        }

        .lia-table-row {
            td {
                padding: map-get($config, spacing-normal) map-get($config, spacing-large);
                border: 1px solid $border-color;
            }

            &:nth-child(even) {
                background: $row-even-bg;
                color: $row-even-fg;
            }

            &:nth-child(odd) {
                background: $row-odd-bg;
                color: $row-odd-fg;
            }
        }
    }

    .lia-card {
        //margin: map-get($config, spacing-small);
        padding: map-get($config, spacing-normal);
        border-radius: 2px;
        box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24);

        .lia-check-item,
        .lia-radio-item,
        .lia-survey-matrix {
            padding: map-get($config, spacing-normal);
        }
    }

    .lia-survey-matrix {
        border-spacing: 0 map-get($config, spacing-large);

        :not(:first-child) {
            td:last-child {
                padding: map-get($config, spacing-normal) map-get($config, spacing-large);
            }

            td:not(:last-child) {
                $bg: map-get($theme, background);
                $fg: color-contrast($bg);
                background: mix($bg, $fg, 95%);
                padding: map-get($config, spacing-normal);
            }
        }

        :first-child td {
            padding: 0 map-get($config, spacing-normal);
        }
    }

    .lia-quote {
      $info: map-get($theme, primary);
      $bg: mix(map-get($theme, background), $info, 90%);
      //$bg: map-get($theme, theme);
      $fg: color-contrast($bg);

      border-left: map-get($config, spacing-normal) solid $info;
      background: $bg;
      color: $fg;
      margin: map-get($config, spacing-huge) map-get($config, spacing-normal);
      padding: map-get($config, spacing-large);

      //todo add shadow with changeing colors according to dark and light...
      border-radius: 5px;
      //box-shadow: 8px 7px 0px #eee;
    }

    .lia-toolbar {
        $bg: map-get($theme, primary);
        $fg: color-contrast($bg);

        z-index: 1;
        flex: 0 0 auto;
        height: map-get($config, toolbar-height);
        background: $bg;
        color: $fg;

        .lia-btn {
            box-shadow: none;
            background: transparent;
            color: $fg;

            &:hover {
                background: mix(transparent, $fg, 80%);
            }

            .lia-ripple {
                background: $fg;
            }
        }

        .lia-input,
        .lia-select {
            background: $bg;
            border-bottom-color: mix($bg, $fg, 50%);

            &:not([disabled]) {
                color: $fg;
            }

            &[disabled] {
                color: rgba($fg, .38);
            }

            &:focus {
                border-bottom-color: $fg;
            }
        }

        .lia-left {
            order: 1;
        }

        .lia-spacer {
            order: 1;
            flex: 1 1 auto;
        }

        .lia-right {
            order: 2;
        }
    }
}
